DECLARE SUB HIGHL (A$)
DECLARE FUNCTION LOGAV! (A!, B!)
DECLARE SUB CLRLNE (I%)
DECLARE SUB CNTR (YT!, A$)
DECLARE FUNCTION PrssNmbr% (N%)
DECLARE FUNCTION CAPNWT$ ()
DECLARE FUNCTION ALGT! (X!)
DECLARE FUNCTION DROUND! (tx1!, ty1!)

DEFINT I-N
FUNCTION ALGT (X) STATIC
   ALGT = LOG(X) / LOG(10)
END FUNCTION

FUNCTION CAPNWT$ STATIC
Cap:
   A$ = INKEY$: IF A$ = "" THEN GOTO Cap
   IF A$ = CHR$(27) THEN GOTO cdone
   IF A$ = CHR$(13) THEN GOTO cdone
   A$ = UCASE$(A$)
   IF A$ < "A" OR A$ > "Z" THEN BEEP: GOTO Cap
cdone: CAPNWT$ = A$
END FUNCTION

SUB CLR5L STATIC
    COLOR 7, 1
    CLRLNE 21
    CLRLNE 22
    CLRLNE 23
    CLRLNE 24
    CLRLNE 25
END SUB

SUB CLRLNE (I) STATIC
LOCATE I, 1: PRINT STRING$(79, " ");
END SUB

SUB CNTR (YT, A$) STATIC
    XT = (80 - LEN(A$)) / 2
    LOCATE YT, XT: HIGHL A$
END SUB

SUB Conves (Vv(), Ves(), Nrad, Xk(), Nc) STATIC
   M = 0
   L = 1
   Ll = Nc
Cnvlv:
   Vs = 0
   FOR J = L TO Ll
      Vs = Vs + Vv(J) * Xk(J - M)
   NEXT J
   Ves(L) = Vs
   L = L + 1
   Ll = Ll + 1
   M = M + 1
   IF Ll <= Nrad GOTO Cnvlv
END SUB

SUB Cubic1 (M, X(), Y(), A(), B(), C(), Delx, xx(), Yy(), K) STATIC
   Xmax = X(M)
   Xmin = X(1)
   K = INT(DROUND((Xmax - Xmin) / Delx, 5)) + 1
   IF K < 1 THEN GOTO L9
   I = M
   xx(K) = Xmax
   Yy(K) = Y(M)
   FOR L = 1 TO K - 1
      J = K - L
      xx(J) = Xmax - (K - J) * Delx
L7:
      IF DROUND(xx(J), 5) >= DROUND(X(I - 1), 5) THEN GOTO L8
      I = I - 1
      GOTO L7
L8:
      Z = xx(J) - X(I - 1)
      Yy(J) = Y(I - 1) + ((C(I - 1) * Z + B(I - 1)) * Z + A(I - 1)) * Z
   NEXT L
   EXIT SUB
L9:
   PRINT "ERROR IN CUBIC1"

END SUB

SUB DELAY (B) STATIC
A = TIMER
WHILE TIMER - A < B: WEND
END SUB

FUNCTION DROUND (tx1, ty1) STATIC
DROUND = INT(.5 + (tx1 * (10 ^ ty1))) / (10 ^ ty1)
END FUNCTION

SUB HIGHL (A$) STATIC
COLOR 0, 7
PRINT A$;
COLOR 7, 1
END SUB

SUB Kernel (L, X(), t(), R(), V(), N) STATIC
   FOR J = 1 TO N
       B = 1
       A = -2 / X(J)
       FOR I = L TO 2 STEP -1
          C = B * R(I)
          D = A * t(I - 1)
          IF D < -10 THEN B = 1: GOTO nxt
          Q = (R(I - 1) - C) / (R(I - 1) + C) * EXP(D)
          B = (1 - Q) / (1 + Q)
nxt:     NEXT I
       V(J) = B * R(1)
   NEXT J
END SUB

DEFSNG I-N
FUNCTION LOGAV (A, B) STATIC
LOGAV = 10 ^ ((ALGT(A) + ALGT(B)) / 2)
END FUNCTION

SUB Logplt (AX(), AY()) STATIC
 x0 = ALGT(AX(1)): xm = ALGT(AX(5))
 y0 = ALGT(AY(1)): ym = ALGT(AY(4))
 WINDOW (x0, y0)-(xm, ym)
 t = .065
FOR I = 1 TO 5
   X = x0 + I - 1
   x1 = 10 ^ X
   LINE (X, y0)-(X, ym)
   FOR J = 2 TO 9
   x2 = ALGT(x1 * J)
   LINE (x2, y0)-(x2, y0 + t)
   LINE (x2, ym - t)-(x2, ym)
   NEXT J
NEXT I
t = .05
FOR I = 1 TO 4
   Y = y0 + I - 1
   y1 = 10 ^ Y
   LINE (x0, Y)-(xm, Y)
   FOR J = 2 TO 9
      y2 = ALGT(y1 * J)
      LINE (x0, y2)-(x0 + t, y2)
      LINE (xm - t, y2)-(xm, y2)
   NEXT J
NEXT I
END SUB

DEFINT I-N
SUB LVES (A(), B(), N, t$, U$, K) STATIC
   INPUT #1, t$
   INPUT #1, U$
      FOR I = 1 TO 45
         IF EOF(K) THEN EXIT FOR
         INPUT #K, A(I), B(I)
      NEXT I
      N = I - 1
   CLOSE #1
END SUB

SUB ONEILL (Xk(), N) STATIC
   Xk(1) = -.000318
   Xk(2) = .002072
   Xk(3) = -.004978
   Xk(4) = .01125
   Xk(5) = -.02521
   Xk(6) = .05812
   Xk(7) = -.1436
   Xk(8) = .393
   Xk(9) = -1.1324
   Xk(10) = 2.7044
   Xk(11) = -3.4507
   Xk(12) = .4248
   Xk(13) = 1.1817
   Xk(14) = .6194
   Xk(15) = .2374
   Xk(16) = .08688
   Xk(17) = .0235
   Xk(18) = .01284
   Xk(19) = -.001198
   Xk(20) = .003042
   N = 20
END SUB

DEFSNG I-N
SUB PRSSANYKY
   LOCATE 25, 1: PRINT STRING$(78, " ");
   CNTR 25, " Press Any Key to Continue "
   WHILE INKEY$ = "": WEND
END SUB

DEFINT I-N
FUNCTION PrssNmbr% (N) STATIC
Prss:
    LOCATE 25, 26
    COLOR 0, 7: PRINT " Please Press Appropriate Number "; : COLOR 7, 1
    A$ = INKEY$
    WHILE A$ = "": A$ = INKEY$: WEND
    K = VAL(A$)
    IF K < 1 OR K > N THEN BEEP: GOTO Prss
   PrssNmbr% = K
END FUNCTION

SUB RMS1 (RhoDig(), Ves(), RMS, Layers) STATIC
   RMS = 0
   FOR I = 1 TO Layers
   RMS = ((RhoDig(I) - Ves(I)) / RhoDig(I)) ^ 2 + RMS
   NEXT I
   RMS = (RMS / Layers) ^ .5 * 100
END SUB

SUB SETCOORD (AX(), AY(), X(), Y(), N) STATIC
   AX(1) = 10 ^ INT(ALGT(X(1)))
   FOR I = 2 TO 5
      AX(I) = AX(I - 1) * 10
   NEXT I
   IF AX(4) > X(N) THEN
      FOR I = 1 TO 5
         AX(I) = AX(I) / 10
      NEXT I
   END IF
   RhoMin = Y(1)
   RhoMax = Y(1)
   FOR I = 1 TO N
      IF Y(I) < RhoMin THEN RhoMin = Y(I)
      IF Y(I) > RhoMax THEN RhoMax = Y(I)
   NEXT I
   AVRHO = EXP((LOG(RhoMin) + LOG(RhoMax)) / 2)
   AY(1) = 10 ^ INT(ALGT(AVRHO)) / 10
   FOR I = 2 TO 4
      AY(I) = AY(I - 1) * 10
   NEXT I
END SUB

SUB SETSCRN STATIC
   SCREEN 0
   COLOR 7, 1
   CLS
END SUB

SUB Shft (ab(), ob(), npts, absh(), obsh(), nsh, iseg) STATIC
   DIM sgmnt(15)
   J = 1
   I = 1
   absh(1) = ab(1)
   obsh(1) = ob(1)
   nsgmnt = 1
   amult = 1
   sgmnt(1) = 1
   s1 = ab(1)
lshift1:
   I = I + 1
   IF I > npts THEN GOTO doneshift
   IF ab(I) > s1 THEN
      J = J + 1
      absh(J) = ab(I)
      obsh(J) = ob(I) * amult
      s1 = ab(I)
   ELSEIF ab(I) = s1 THEN
      amult = obsh(J) / ob(I)
      nsgmnt = nsgmnt + 1
      sgmnt(nsgmnt) = amult
   ELSE
   END IF
   GOTO lshift1
doneshift:
   nsh = J
   IF iseg >= nsgmnt OR iseg < 1 THEN EXIT SUB
   I = nsgmnt - iseg + 1
   amult = sgmnt(I)
   FOR J = 1 TO nsh
      obsh(J) = obsh(J) / amult
   NEXT J
END SUB

SUB Spline1 (M, H, X(), Y(), A(), B(), C(), t, D(), P(), S()) STATIC
   IF (t < 0) OR (t > 1) OR (H < 0) OR (M < 3) THEN GOTO L999
   N = M - 1
   IF t >= 0 THEN GOTO L20
   Ne = N - 1
   IF H = 0 THEN GOTO L11
L1:
   Hh = 3 / H
   FOR I = 1 TO Ne
      B(I) = 4
      A(I) = 1
      C(I) = 1
      P(I) = Hh * (Y(I + 2) - Y(I))
   NEXT I
   P(1) = P(1) - D(1)
   P(Ne) = P(Ne) - D(2)
L3:
   C(1) = C(1) / B(1)
   P(1) = P(1) / B(1)
   FOR I = 2 TO Ne
      Mul = 1 / (B(I) - A(I) * C(I - 1))
      C(I) = Mul * C(I)
      P(I) = Mul * (P(I) - A(I) * P(I - 1))
   NEXT I
   A(Ne + t) = P(Ne)
   I = Ne - 1
L5:
   A(I + t) = P(I) - C(I) * A(I + t + 1)
   I = I - 1
   IF I >= 1 THEN GOTO L5
   IF t = 0 THEN GOTO L6
   A(1) = D(1)
   A(M) = D(2)
L6:
   IF H = 0 THEN GOTO L14
   Hh = 1 / H
   FOR I = 1 TO N
      Mul = Hh * (Y(I + 1) - Y(I))
      B(I) = Hh * (3 * Mul - (A(I + 1) + 2 * A(I)))
      C(I) = Hh * Hh * (-2 * Mul + A(I + 1) + A(I))
   NEXT I
   GOTO Rtn
L11:
   FOR I = 1 TO N
      S(I + 1) = X(I + 1) - X(I)
   NEXT I
   FOR I = 1 TO Ne
      B(I) = 2 * (S(I + 1) + S(I + 2))
      C(I) = S(I + 1)
      A(I) = S(I + 2)
      P(I) = 3 * (S(I + 1) ^ 2 * (Y(I + 2) - Y(I + 1)) + S(I + 2) ^ 2 * (Y(I + 1) - Y(I))) / (S(I + 1) * S(I + 2))
   NEXT I
   P(1) = P(1) - S(3) * D(1)
   P(Ne) = P(Ne) - S(N) * D(2)
   GOTO L3
L14:
   FOR I = 1 TO N
      Hh = 1 / S(I + 1)
      Mul = (Y(I + 1) - Y(I)) * Hh ^ 2
      B(I) = 3 * Mul - (A(I + 1) + 2 * A(I)) * Hh
      C(I) = -2 * Mul * Hh + (A(I + 1) + A(I)) * Hh ^ 2
   NEXT I
   GOTO Rtn
L20:
   Ne = N + 1
   IF H = 0 THEN GOTO L31
   Hh = 3 / H
   FOR I = 2 TO N
      P(I) = Hh * (Y(I + 1) - Y(I - 1))
      B(I) = 4
      C(I) = 1
      A(I) = 1
   NEXT I
   B(1) = 2
   B(Ne) = 2
   C(Ne) = 1
   A(Ne) = 1
   P(1) = Hh * (Y(2) - Y(1)) - .5 * H * D(1)
   P(Ne) = Hh * (Y(M) - Y(N)) + .5 * H * D(2)
   GOTO L3
L31:
   FOR I = 1 TO N
      S(I + 1) = X(I + 1) - X(I)
   NEXT I
   N1 = N - 1
   FOR I = 1 TO N1
      B(I + 1) = 2 * (S(I + 1) + S(I + 2))
      C(I + 1) = S(I + 1)
      A(I + 1) = S(I + 2)
      P(I + 1) = 3 * (S(I + 1) ^ 2 * (Y(I + 2) - Y(I + 1)) + S(I + 2) ^ 2 * (Y(I + 1) - Y(I))) / (S(I + 1) * S(I + 2))
   NEXT I
   B(1) = 2
   B(Ne) = 2
   C(1) = 1
   C(Ne) = 1
   A(Ne) = 1
   P(1) = 3 * (Y(2) - Y(1)) / S(2) - .5 * S(2) * D(1)
   P(Ne) = 3 * (Y(M) - Y(N)) / S(M) + .5 * S(M) * D(2)
   GOTO L3
L999: PRINT "ERROR IN SPLIN1"

Rtn: END SUB

